//=======================================================================
//                        MicroBoard LX9 USBHOST
//
// File:
//   fm_ddio.v
//
// Abstract:
//   ALTDDIO_OUT wrapper
//  Created:
//    12 March 2014
//======================================================================
//
// Copyright (c) 2014, Kenji Ishimaru
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//
//  -Redistributions of source code must retain the above copyright notice,
//   this list of conditions and the following disclaimer.
//  -Redistributions in binary form must reproduce the above copyright notice,
//   this list of conditions and the following disclaimer in the documentation
//   and/or other materials provided with the distribution.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
// AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
// OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
// WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
// OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
// EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Revision History
// $Date: 2014-04-03 13:30:47 +0900 (Thu, 03 Apr 2014) $
// $Rev: 50 $

module fm_ddio (
  input clk,
  input rst_x,
  input i_data_h,
  input i_data_l,
  output o_data_p,
  output o_data_n
);

reg r_data_h_p;
reg r_data_h_n;
reg r_data_l_p;
reg r_data_l_n;

always @(posedge clk) begin
  r_data_h_p <= i_data_h;
  r_data_l_p <= i_data_l;
  r_data_h_n <= ~i_data_h;
  r_data_l_n <= ~i_data_l;
end

FDDRRSE u_FDDRRSE_p (
.Q(o_data_p),
.C0(~clk),
.C1(clk),
.CE(1'b1),
.D0(r_data_h_p),
.D1(r_data_l_p),
.R(1'b0),
.S(1'b0)
);

FDDRRSE u_FDDRRSE_n (
.Q(o_data_n),
.C0(~clk),
.C1(clk),
.CE(1'b1),
.D0(r_data_h_n),
.D1(r_data_l_n),
.R(1'b0),
.S(1'b0)
);


endmodule


