/*
 * Simple Mouse Example.
 *
 *
 */

#include <stdio.h>
#include <string.h>
#include "platform.h"
#include "usbh_hw_reg.h"
#include "usbh_env.h"
#include "video.h"

un_hid_mouse mouse_data;
volatile int fit_status;
volatile int video_status;
volatile int fb_front;

#define IRQ_STATUS (*(volatile unsigned int *)(0x80000030))
#define IRQ_ENABLE (*(volatile unsigned int *)(0x80000038))
#define IRQ_ACK (*(volatile unsigned int *)(0x8000003c))

void fit_func() {
    int status;
	microblaze_disable_interrupts();
	status = IRQ_STATUS;
	if (status & 0x80) {
	  fit_status = 1;// fit
	  IRQ_ACK = 0x00000080;
	}
	if (status & 0x10000) {
	  video_status = 1;// video
	  if (VIDEO_STATUS) VIDEO_STATUS = 0;
	  IRQ_ACK = 0x00010000;
	}
	microblaze_enable_interrupts();
}
// mouse callback
void on_mouse(int buttons, int x, int y, int z) {
  mouse_data.BYTE.x = x;
  mouse_data.BYTE.y = y;
  mouse_data.BYTE.b = buttons;
  xil_printf("mouse changed %x %x %x %x\r\n",buttons,x,y,z);
}

int main()
{
    init_platform();

    xil_printf("USB HOST mouse demo\n\r");
    //xil_printf("VERSION %x\n\r", USB_HOST_SLAVE_VERSION_REG(0));
    microblaze_register_handler((XInterruptHandler)fit_func,(void*)0);

    // enable FIT1 & Video Int
    (*(volatile unsigned int *)(0x80000038)) = 0x00010080;
    microblaze_enable_interrupts();

    fit_status = 0;
    video_status = 0;

    uh_init();
    uh_mouse_attach_func(on_mouse);
    video_init();

    // HID loop
    while(1) {
  	  uh_update();
  	  video_update();
    }
    return 0;
}

